# Cloud message send

An action block that sends a “cloud” message through the internet to another device running Automate.

If the proceed option is set to Immediately, then the message is enqueued for sending without pausing the fiber, a failure to send is silently ignored. If set to When sent, then the fiber will pause until the message has been successfully sent to the server, or failed to do so, this acknowledged that may not be immediate for each message. A failure to send will cause the fiber to stop unless Failure catch block is used.

Use a Cipher account, with a strong password, to ensure that only a recipient knowing the password can receive the message. The message is then encrypted on the sender device with a AES-GCM cipher using a key derived (PBKDF2) from the password. The encryption is end-to-end, the server are not involved and can’t access the password, nor the payload.

Messages can also be sent from any source capable of making HTTP(S) requests, see https://llamalab.com/automate/cloud/.

This block requires a device with a working Google Play services installed.

Privacy warning! The Google account name (e-mail address) and device brand are used for addressing, both are sent to the recipient via a server. See Privacy policy.

## Options

- Proceed — when the fiber should proceed.

## Input arguments

- From Google account — name of Google account to send message as.
- To Google account — name (e-mail) of recipient Google account.
- To device — brand of recipient device, case-sensitive, default is all devices.
- Cipher account — name of generic credentials account where the password will be used to encrypt the message, default is unencrypted.
- Priority — whether to request “high priority” delivery, possibly awakening the recipient device. Use sparingly as it may be throttled by Google.
- Payload — payload passed to the recipient, maximum size is 2 KB.